"
 (C) 2014 by Holger Hans Peter Freyther
 All Rights Reserved

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
"

Osmo.OsmoStreamSocketBase subclass: SMPPConnection [
    | writeQueue nextSeq systemId password systemType |
    <category: 'SMPP-Connection'>

    createConnection: aHostname port: aPort [
        <category: 'socket'>
        ^ Sockets.StreamSocket remote: aHostname port: aPort.
    ]

    systemId: anId [
        systemId := anId
    ]

    password: aPassword [
        password := aPassword
    ]

    systemType: aType [
        systemType := aType
    ]

    scheduleBindTrx [
        | header body |

        header := SMPPPDUHeader new
                    commandId: SMPPBindTransceiver messageType;
                    commandStatus: 0;
                    yourself.
        body := SMPPBindTransceiver new
                    systemId: systemId;
                    password: password;
                    systemType: systemType;
                    version: 16r34;
                    numberingPlanIndicator: 0;
                    typeOfNumber: 0;
                    addressRange: #[];
                    yourself.

        self send: (SMPPMessage new
                    header: header;
                    body: body)
    ]

    send: aMessage [
        | seq |
        seq := nextSeq.
        nextSeq := nextSeq + 1.

        aMessage header sequenceNumber: seq.
        writeQueue nextPut: aMessage toMessage asByteArray
    ]

    connect [
        super connect.
        nextSeq := 0.
        writeQueue := SharedQueue new.
        self scheduleBindTrx.
    ]

    sendOne [
        | msg |
        "TODO: Pill of death!"
        msg := writeQueue next.
        socket nextPutAllFlush: msg.
    ]

    dispatchOne [
        | msg |

        [
            msg := SMPPMessage readFrom: socket.
            msg body connectionDispatchOn: self with: msg
        ] on: Error do: [:e |
            e
                inspect;
                pass
        ]
    ]

    respondToEnquire: aMessage [
        | msg |
        msg := SMPPMessage new
                    header: (SMPPPDUHeader new
                                commandId: SMPPBodyBase enquireLinkResp;
                                commandStatus: 0;
                                sequenceNumber: aMessage header sequenceNumber;
                                yourself);
                    body: #[].
        writeQueue nextPut: msg toMessage asByteArray
    ]

    receviedResponse: aMessage [
    ]
]
